<?php

namespace App\Http\Controllers;
use App\TipoSocio;
use App\Producto;
use App\Bonificacion;
use App\ListaPrecios;
use App\ListaPreciosProducto;
use App\ListaPreciosProductosBonificacion;

use Illuminate\Support\Facades\Validator;

use Illuminate\Http\Request;

class PreciosController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $listaPrecios=ListaPrecios::with('tipo_socio')
                ->get();
        return view('precios.lista',compact('listaPrecios'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $tiposSocios=TipoSocio::all();
        $productos=Producto::all();
        $bonificaciones=Bonificacion::all();
        return view('precios.nuevo',compact('tiposSocios','productos','bonificaciones'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //

        $validator = Validator::make($request->all(), [
            'id_tipo_socio' => 'required|unique:crm_listas_precios',
        ]);
        if ($validator->fails()) {
            $arrResponse = [
                'message' => 'La lista ya existe, no se guardado correctamente'
            ];
            return redirect()->back()->withInput()->with($arrResponse);
            dd();
        }

        $listaPrecios = new ListaPrecios();
        $listaPrecios->nombre = $request->nombre_lista;
        $listaPrecios->id_tipo_socio = $request->id_tipo_socio;
        $listaPrecios->save();

        if($listaPrecios->id){
            $i=0;
            while(isset($request->id_producto[$i])){
                $listaPreciosProducto = new ListaPreciosProducto();
                $listaPreciosProducto->id_lista = $listaPrecios->id;
                $listaPreciosProducto->id_producto = $request->id_producto[$i];
                $listaPreciosProducto->precio_base = $request->precioBase[$i];
                $listaPreciosProducto->precio_piso = $request->precioPiso[$i];
                $listaPreciosProducto->porcentaje_eva = $request->porcentaje_eva[$i];
                $listaPreciosProducto->save();
                $i++;
                $nombre='id_bonificacion'.$i;
                $nombre2='id_bonificacion_eva'.$i;
                $kk=0;

                foreach ($request[$nombre] as $value) {
                    echo $request[$nombre2][$kk];

                    $bonificacion = new ListaPreciosProductosBonificacion();
                    $bonificacion->id_lista_producto = $listaPreciosProducto->id;
                    $bonificacion->id_bonificacion_eva = $request[$nombre2][$kk];
                    $bonificacion->id_bonificacion = $value;
                    $bonificacion->save();
                    $kk++;

                }
            }
            $arrResponse = [
                'message' => 'Lista de precios guardada correctamente'
            ];
            return redirect()->route('marketing.precios')->with($arrResponse);
        }
        $arrResponse = [
            'message' => 'Error no se guardado correctamente'
        ];
        return redirect()->route('marketing.precios')->with($arrResponse);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
